#ifndef __eeprom_H__
#define __eeprom_H__
#include <TridentTD_ESP32NVS.h>

class Eeprom
{
private:

public:
    Eeprom();
    ~Eeprom();
    void set_int(String name , uint64_t val );
    void set_int_period(String name , uint64_t val , time_t period_ms);
    uint64_t get_int(String name );
    void begin();
};

Eeprom::Eeprom()
{
}

Eeprom::~Eeprom()
{
}

void Eeprom::begin()
{
    Serial.println("Init EEPROM ...");
    NVS.begin();
}

void Eeprom::set_int_period(String name , uint64_t val , time_t period_ms)
{
    static time_t last_stored_ms = 0;
    if((last_stored_ms == 0) || ((millis() - last_stored_ms) > period_ms))
    {
        last_stored_ms = millis();
        set_int(name , val );
    }
}

void Eeprom::set_int(String name , uint64_t val )
{
   if(NVS.getInt(name) != val)
   {
    NVS.setInt(name, val);
   }
}

uint64_t Eeprom::get_int(String name )
{
   return NVS.getInt(name);
}

#endif